from cProfile import label
from sqlite3 import Row
import websockets,asyncio
import io,base64
import cv2  
import numpy as np
import matplotlib.pyplot as plt
from PIL import Image
import tkinter as tk

root = tk.Tk()
e = tk.Entry(root, width= 29)
e2 = tk.Entry(root, width= 13)
e3 = tk.Entry(root, width= 50)
label01 = tk.Label(root, text="IP: ")
label02 = tk.Label(root, text="Port: ")
label03 = tk.Label(root, text="Address: ")

label01.grid(row=0,column=0)
e.grid(row=0,column=1)
label02.grid(row=0,column=2)
e2.grid(row=0,column=3)
label03.grid(row=1,column=0)
def onClickOnManual():
    global usedIP
    usedIP = e.get()
    usedPort = e2.get()
    usedIP = "ws://" + usedIP + ":"+usedPort+"/RemoSharp"
    root.destroy()

def onClickOnFullAddress():
    global usedIP
    usedIP = e.get()
    usedPort = e3.get()
    usedIP = usedPort
    root.destroy()
    


ManualButton = tk.Button(root, text='Set Address', command=onClickOnManual)

ManualButton2 = tk.Button(root, text='Full Address', command=onClickOnFullAddress)

ManualButton.grid(row=0,column=4)
e3.grid(row=1,column=1,columnspan=3)
ManualButton2.grid(row=1,column=4)

root.mainloop()
print("Connecting To " + usedIP + '\n')

def stringToImage(base64_string):
    
    imgdata = base64.b64decode(base64_string)
    return Image.open(io.BytesIO(imgdata))

def toRGB(image):
    return cv2.cvtColor(np.array(image), cv2.COLOR_BGR2RGB)

bounds = "0,200,0,200"

async def listen2():
    global bounds
    url = "ws://127.0.0.1:6999/RemoSharpCanvasBounds"
    async with websockets.connect(url) as ws:
        bounds = await ws.recv()
        # print(bounds)
async def listen(usedIP):
    

    async with websockets.connect(usedIP) as ws:
        

            
        msg = await ws.recv()
        decoded_data = base64.b64decode(msg)
        np_data = np.fromstring(decoded_data,np.uint8)
        img = cv2.imdecode(np_data,cv2.IMREAD_UNCHANGED)
        ogBounds = img.shape
        boundExtents = bounds.split(',')
        x = int(boundExtents[0])
        xDim = int(boundExtents[1])
        y = int(boundExtents[2])
        yDim = int(boundExtents[3])
        zoomVal = float(boundExtents[4])
        PosX = int(boundExtents[5])
        PosY = int(boundExtents[6])
        scale = int(boundExtents[7])
        scaleup = 1
        if scale == 50:
            scaleup = 2
            x = x + 100
            y = y + 100
        if scale == 100:
            scaleup = 1
        scale_percent = zoomVal * 100 * scaleup# percent of original size
        width = int(img.shape[1] * scale_percent / 100)
        height = int(img.shape[0] * scale_percent / 100)
        dim = (width, height)
        
        winname = "Grasshopper Broadcast"
        cv2.namedWindow(winname)
        cv2.moveWindow(winname, PosX,PosY)

        # resize image
        img = cv2.resize(img, dim, interpolation = cv2.INTER_AREA)

        imageCrop = img[x:x + xDim,y:y + yDim]
        # imageCrop = img[:,:]
        print(ogBounds)
        print(boundExtents)
        cv2.imshow(winname, imageCrop)
        cv2.waitKey(1)         

while True:

    try:
        asyncio.get_event_loop().run_until_complete(listen2())
        asyncio.get_event_loop().run_until_complete(listen(usedIP)) 
    except:
        print("Problem with Sync Range!")